/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mycompany.ctfposhbot_b;

import cz.cuni.amis.pogamut.base.utils.math.DistanceUtils;
import cz.cuni.amis.pogamut.base3d.worldview.object.Location;
import cz.cuni.amis.pogamut.sposh.context.UT2004Context;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateSense;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.UT2004Navigation;

/**
 *
 * @author Jan Vojt <jan@vojt.net>
 * @copyright (c) 2012 Jan Vojt
 */
@PrimitiveInfo(name = "canSeeEnemyFlag", description = "Do I think I know where enemy flag is?")
public class CanSeeEnemyFlag extends StateSense<UT2004Context, Boolean> {

    public CanSeeEnemyFlag(UT2004Context ctx) {
        super("canSeeEnemyFlag", ctx);
    }
    
    @Override
    public Boolean query(VariableContext vc) {
		boolean visible = ctx.getCtf().getEnemyFlag().isVisible();
		Location located = ctx.getCtf().getEnemyFlag().getLocation();
		
		// if last known location is at home base ignore it
		// this often happens when a bot can see score another bot
		// and thinks the enemy flag is at home base
		if (located !=null && ctx.getCtf().getOurBase().getLocation().getDistance(located) < UT2004Navigation.AT_PLAYER)
			located = null;
		
        return visible || located != null;
    }
	
}
