/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mycompany.ctfposhbot_b;

import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.agent.module.utils.TabooSet;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.UT2004Navigation;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Item;
import cz.cuni.amis.utils.collections.MyCollections;
import java.util.Collection;

/**
 *
 * @author Jan Vojt <jan@vojt.net>
 * @copyright (c) 2012 Jan Vojt
 */
@PrimitiveInfo(name = "collectItems", description = "Collect Items.")
public class CollectItems extends StateAction<CTFContext> {
	
	
	/**
	 * Items known to be unspawned
	 */
	protected TabooSet<Item> tabooItems;
	
	/**
	 * Item currently being pursued
	 */
	private Item item;

	
    public CollectItems(CTFContext ctx) {
        super("collectItems", ctx);
    }

	@Override
	public void init(VariableContext vc) {
		tabooItems = new TabooSet<Item>(ctx.getBot());
	}

	@Override
	public ActionResult run(VariableContext vc) {
		
		ctx.getLog().info("Collecting items.");
		
		// if we reached healt pack, tabooize and clear it
		if (item != null && ctx.getInfo().getLocation().getDistance(item.getLocation())<UT2004Navigation.AT_PLAYER) {
			double tm = ctx.getItems().getItemRespawnTime(item);
			
			// lets prevent picking same items with zero respawn time
			if (tm < 1) tm = 120;
			
			tabooItems.add(item, tm);
			item = null;
		}
		
		// if we do not have any taget pack, select one
		if (item == null) {
			Collection spawned = ctx.getItems().getSpawnedItems().values();
			
			if (spawned.isEmpty()) return ActionResult.FINISHED;
			
			Collection packs = MyCollections.getFiltered(spawned, tabooItems);
			if (packs.isEmpty())
				item = ctx.getFwMap().getNearestItem(spawned, ctx.getInfo().getNearestNavPoint());
			else
				item = ctx.getFwMap().getNearestItem(packs, ctx.getInfo().getNearestNavPoint());
		}
		
		ctx.getNavigation().navigate(item);
		
		return ActionResult.RUNNING;
	}

	@Override
	public void done(VariableContext vc) {
		ctx.getNavigation().stopNavigation();
	}
	

}
