/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mycompany.ctfposhbot_b;

import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.agent.module.utils.TabooSet;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.UT2004Navigation;
import cz.cuni.amis.pogamut.ut2004.communication.messages.ItemType;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Item;
import cz.cuni.amis.utils.collections.MyCollections;
import java.util.Collection;

/**
 *
 * @author Jan Vojt <jan@vojt.net>
 * @copyright (c) 2012 Jan Vojt
 */
@PrimitiveInfo(name = "collectMedikits", description = "Collect Medikits.")
public class CollectMedikits extends StateAction<CTFContext> {
	
	/**
	 * Health pack currently being pursued
	 */
	private Item pack;
	
	/**
	 * Items known to be unspawned
	 */
	protected TabooSet<Item> tabooItems;

    public CollectMedikits(CTFContext ctx) {
        super("collectMedikits", ctx);
    }

	@Override
	public void init(VariableContext vc) {
		tabooItems = new TabooSet<Item>(ctx.getBot());
	}

	@Override
	public ActionResult run(VariableContext vc) {
		
		ctx.getLog().info("Collection health packs.");
		
		// if we reached healt pack, tabooize and clear it
		if (pack != null && ctx.getInfo().getLocation().getDistance(pack.getLocation())<UT2004Navigation.AT_PLAYER) {
			double tm = ctx.getItems().getItemRespawnTime(pack);
			tabooItems.add(pack, tm);
			pack = null;
		}
		
		// if we do not have any taget pack, select one
		if (pack == null) {
			Collection packs = MyCollections.getFiltered(ctx.getItems().getSpawnedItems(ItemType.HEALTH_PACK).values(), tabooItems);
			pack = ctx.getFwMap().getNearestItem(packs, ctx.getInfo().getNearestNavPoint());
		}
		
		ctx.getNavigation().navigate(pack);
		
		return ActionResult.RUNNING;
	}

	@Override
	public void done(VariableContext vc) {
		ctx.getNavigation().stopNavigation();
	}
	
	

}
