/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mycompany.ctfposhbot_b;

import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.agent.navigation.UT2004Navigation;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.NavPoint;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;

/**
 *
 * @author Jan Vojt <jan@vojt.net>
 * @copyright (c) 2012 Jan Vojt
 */
@PrimitiveInfo(name = "defendFlag", description = "Camp at our flag and shoot enemies.")
public class DefendFlag extends StateAction<CTFContext> {
	
	private NavPoint ourBase;

    public DefendFlag(CTFContext ctx) {
        super("defendFlag", ctx);
    }

	@Override
	public void init(VariableContext vc) {
		ourBase = ctx.getCtf().getOurBase();
	}

	@Override
	public ActionResult run(VariableContext vc) {
		
		ctx.getLog().info("Defending our flag.");
		
		float distance = ctx.getFwMap().getDistance(ourBase, ctx.getInfo().getNearestNavPoint());
		
		if (distance < UT2004Navigation.AT_PLAYER*2) {
			//we are standing at home base
			ctx.getNavigation().stopNavigation();
			
			Player p = ctx.getPlayers().getNearestVisibleEnemy();
			if (p == null && ctx.getInfo().isShooting()) {
				// we cannot see enemy -> stop shooting and keep turning around
				ctx.getShoot().stopShooting();
				ctx.getMove().turnHorizontal(45);
			} else if (p != null) {
				ctx.getShoot().shoot(ctx.getWeaponPrefs(), p);
				ctx.getMove().turnTo(p);
			} else {
				ctx.getMove().turnHorizontal(45);
			}
			
		} else {
			// we are not at home base
			ctx.getNavigation().navigate(ourBase);
		}
		
		return ActionResult.RUNNING;		
	}

	@Override
	public void done(VariableContext vc) {
		ctx.getShoot().stopShooting();
		ctx.getNavigation().stopNavigation();
	}
	
	
}
