/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package com.mycompany.ctfposhbot_b;

import cz.cuni.amis.pogamut.sposh.context.UT2004Context;
import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateSense;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.FlagInfo;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.NavPoint;

/**
 *
 * @author Jan Vojt <jan@vojt.net>
 * @copyright (c) 2012 Jan Vojt
 */
@PrimitiveInfo(name = "OFCTEF", description = "Is Our Flag Closer Than Enemy Flag?")
public class OFCTEF extends StateSense<UT2004Context, Boolean> {

    public OFCTEF(UT2004Context ctx) {
        super("OFCTEF", ctx);
    }
    
    @Override
    public Boolean query(VariableContext vc) {
		
		FlagInfo ourFlag = ctx.getCtf().getOurFlag();
		FlagInfo enemyFlag = ctx.getCtf().getEnemyFlag();
		NavPoint me = ctx.getInfo().getNearestNavPoint();
		
		// location of either flag may be unknown
		if (ourFlag.getLocation() == null || enemyFlag.getLocation() == null)
			return true;
		
		float ourDistance = ctx.getFwMap().getDistance(
				ctx.getInfo().getNearestNavPoint(ourFlag.getLocation()),
				me
		);
		
		float enemyDistance = ctx.getFwMap().getDistance(
				ctx.getInfo().getNearestNavPoint(enemyFlag.getLocation()),
				me
		);
		
		
        return ourDistance < enemyDistance;
    }

}
