/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ctfposhbot_b;

import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.unreal.communication.messages.UnrealId;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.FlagInfo;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;

/**
 *
 * @author vojtj
 */
@PrimitiveInfo(name = "protectFlag", description = "Run around map.")
public class ProtectFlag extends StateAction<CTFContext> {
    
	private FlagInfo flag;
	
    public ProtectFlag(CTFContext ctx) {
        super("protectFlag", ctx);
    }

    @Override
    public void init(VariableContext vc) {
		flag = ctx.getCtf().getOurFlag();
    }

    @Override
    public ActionResult run(VariableContext vc) {
		
		// make sure flag location is known
//		if (flag.getLocation() == null) return false;
		
		ctx.getNavigation().navigate(flag.getLocation());
        
		if (flag.isVisible()) {
			Player p = ctx.getPlayers().getPlayer(flag.getHolder());
			if (p == null && ctx.getInfo().isShooting()) ctx.getShoot().stopShooting();
			else if (p != null && p.isVisible())
				ctx.getShoot().shoot(ctx.getWeaponPrefs(), p);
		}
		
        return ActionResult.RUNNING;
    }

    @Override
    public void done(VariableContext vc) {
		ctx.getNavigation().stopNavigation();
		ctx.getShoot().stopShooting();
    }
}
