/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.mycompany.ctfposhbot_b;

import cz.cuni.amis.pogamut.sposh.engine.VariableContext;
import cz.cuni.amis.pogamut.sposh.executor.ActionResult;
import cz.cuni.amis.pogamut.sposh.executor.PrimitiveInfo;
import cz.cuni.amis.pogamut.sposh.executor.StateAction;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.NavPoint;
import cz.cuni.amis.pogamut.ut2004.communication.messages.gbinfomessages.Player;

/**
 *
 * @author vojtj
 */
@PrimitiveInfo(name = "runHome", description = "Run to home base.")
public class RunHome extends StateAction<CTFContext> {

    private NavPoint ourBase;
    
    public RunHome(CTFContext ctx) {
        super("runHome", ctx);
    }
    
    @Override
    public void init(VariableContext vc) {
        ourBase = ctx.getCtf().getOurBase();
    }

    @Override
    public ActionResult run(VariableContext vc) {
		
        ctx.getNavigation().navigate(ourBase);
		
		ctx.getLog().info("Homerun baby.");
		
		// shoot enemies on the way
		Player p = ctx.getPlayers().getNearestVisibleEnemy();
		if (p == null && ctx.getInfo().isShooting()) ctx.getShoot().stopShooting();
		else if (p != null) ctx.getShoot().shoot(ctx.getWeaponPrefs(), p);
		
        return ActionResult.RUNNING;
    }

    @Override
    public void done(VariableContext vc) {
        ctx.getNavigation().stopNavigation();
		ctx.getShoot().stopShooting();
    }
    
}
